﻿using System;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Threading;

namespace Performancetest
{
    //Klasse zum Umleiten der Konsolenausgabe in eine übergebene GUI-Textbox
    public class TextBoxStreamWriter : TextWriter
    {
        TextBox _output = null;

        public TextBoxStreamWriter(TextBox output)
        {
            _output = output;
        }

        public override void Write(char value)
        {
            if (_output.InvokeRequired)
            {
                _output.Invoke((MethodInvoker)(() => Write(value)));
                return;
            }
            base.Write(value);
            _output.AppendText(value.ToString()); // When character data is written, append it to the text box.
        }

        public override Encoding Encoding
        {
            get { return System.Text.Encoding.UTF8; }
        }
    }
}
